-- Filllevel Anzeige
-- Version: 1.0.1 UAL
--
-- initial version by: Killabot / HOT team
-- improved script by HoFFi (moddwin-welt.com)
--
-- Changelog:
--		- added alignment to display resolution
--		- move hud to top of engine-hud
--		- added dependency to number of loaded goods and state of workmode UAL -> prevent too much HUD-entries when UAL is in unload-mode ("unload Z" not showing)
--		- added coloring of fillscale reaching max. level
--
SFL = {};

function SFL.prerequisitesPresent(specializations)
    return true;
end;

function SFL:load(savegame)
    -- HUD
    self.file = Utils.getFilename("Textur/counter.png", self.baseDirectory);
    --self.HUDx = 0.8485;
    --self.HUDy = 0.164;
    --self.HUDWidth = 0.220;
    --self.HUDHeight = 0.320;
	
	self.HUDx = g_currentMission.vehicleHudBg.x;
    self.HUDy = g_currentMission.vehicleHudBg.y + g_currentMission.vehicleHudBg.height;
    self.HUDWidth = g_currentMission.vehicleHudBg.width
    self.HUDHeight = 0.320;
    self.HUD = false;
    
    self.cX = self.HUDx + 0.03;
    self.cY = self.HUDy + 0.015;
	
	
    
    self.APHUD = Overlay:new("APHUD", self.file, self.HUDx, self.HUDy, self.HUDWidth, self.HUDHeight);
end;

function SFL:delete()
end;

function SFL:readStream(streamId, connection)
end;

function SFL:writeStream(streamId, connection)
end;

function SFL:readUpdateStream(streamId, timestamp, connection)
end;

function SFL:writeUpdateStream(streamId, connection, dirtyMask)
end;

function SFL:mouseEvent(posX, posY, isDown, isUp, button)
end;

function SFL:keyEvent(unicode, sym, modifier, isDown)
end;

function SFL:update(dt)
    if self:getIsActiveForInput() and self:getIsActive() then
        if InputBinding.hasEvent(InputBinding.fillLevel) then
            self.HUD = not self.HUD;
        end;
    end;
end;

function SFL:draw()
	if self.isClient and self:getIsActiveForInput() then
		if self.fillLevel == 0 and not UAL.workMode then
			if self.HUD then
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("HUD_OFF"), self.typeDesc), InputBinding.fillLevel);
			else
				g_currentMission:addHelpButtonText(string.format(g_i18n:getText("HUD_ON"), self.typeDesc), InputBinding.fillLevel);
			end;
		else
			--print ("Hud-Eintrag wird nicht angezeigt da UAL grad aktiv ist....Vermeidung von zu vielen Hilfefenstereinträgen. Deshalb spamme ich lieber die Log zu.");
		end;
		if self.HUD then
			self.APHUD:render();
			if self.fillLevel > 0 then
				if self.fillLevel == self.capacity then
					setTextColor(1, 0, 0, 1.0);
					setTextBold(true);
				elseif self.fillLevel == (self.capacity -1) then
					setTextColor(1, 0.2, 0, 1.0);
				elseif self.fillLevel == (self.capacity -2) then
					setTextColor(1, 0.5, 0, 1.0);
				elseif self.fillLevel == (self.capacity -3) then
					setTextColor(1, 0.9, 0, 1.0);
				else
					setTextColor(1, 1, 1, 1.0);
				end;
			end;
			setTextAlignment(RenderText.ALIGN_LEFT);
			if self.fillLevel > 0 then
			renderText(self.cX, self.cY, 0.015, string.format(g_i18n:getText("input_fillLevel"), self.typeDesc) .. " " .. string.format(self.fillLevel) .. " / " .. string.format(self.capacity));
			else
			setTextColor(0, 0.85, 0, 1.0);
			renderText(self.cX, self.cY, 0.015, "Universal Auto Load");
			end;
		end;
	end;
end;

function SFL:onDetach()
end;
